;innan 13e4
;sen   1288
 include "tios.h"

 xdef _main
 xdef _ti89
 xdef _comment

shiftperrow equ 5
shiftpersprite equ 3
levelptrindex equ 12

QUIRKIDENT equ "QK"
_main:
  ; First, some memory is needed. 1 kb + 256 bytes should be just about fine
  move.l #1024+256,-(a7)
  jsr tios::HeapAlloc
  add.l #4,a7
  tst.w d0
  beq m_memoryerror

  lea areahandle(pc),a2

  move.w d0,(a2)+
  tios::DEREF d0,a0
  move.l a0,(a2)+

  lea 1024(a0),a1
  move.l a1,(a2)

m_loop:
  lea num_files(pc),a4
  
  bsr main_screen

  tst.l levelptrindex(a4)
  beq.b m_quit

  ;Load level
  move.l levelptrindex(a4),a0
  bsr load_level

  bsr scroll_to_player

  lea exitdata(pc),a0
  clr.l (a0)+                   ;Clear exitdata, curplayeranim
  clr.w (a0)                    ;Clear timepassed

  clr.l d7
  clr.l d6
  ; Keyboard handler
m_kbdagain:
  add #1,d7
  move.l d7,d0
  and.l #8191,d0
  bne.b m_donttimer
  lea timepassed(pc),a0
  add.w #1,(a0)
  and.l #16383,d7
  bne.b m_dontanim
  bsr repaint_player_switch
m_dontanim:
m_donttimer:

  bsr.b kbd_proc
  tst.w d0
  beq m_kbdagain

  cmp.w #2,d0
  beq m_loop

  bsr show_level_finished

  lea num_files(pc),a0

  move.w 8(a0),d0               ;Cur level
  add #1,d0
  move.w d0,8(a0)
  cmp.w 10(a0),d0

  ble m_loop
  clr.l 8(a0)

  bra m_loop

m_quit:
  ; Free the memory handle
  move.w areahandle(pc),-(a7)
  jsr tios::HeapFree
  add #2,a7

m_memoryerror:
  ; Quit
  rts

;**********
;Keyboard proc
;**********
kbd_proc:
  movem.l d1-d2/a0,-(a7)
  tst.w (tios::kb_vars+$1C)
  beq.b kbd_nokey

  move.w (tios::kb_vars+$1E),d2
  clr.w  (tios::kb_vars+$1c)

  clr.l d0
  clr.l d1

  cmp.w #337,d2
  beq.b kbd_up
  cmp.w #338,d2
  beq.b kbd_left
  cmp.w #340,d2
  beq.b kbd_down
  cmp.w #344,d2
  beq.b kbd_right
  cmp.w #264,d2
  beq.b kbd_exitkey
  cmp.w #263,d2
  beq.b kbd_switchplayer
  cmp.w #53,d2
  beq.b kbd_scrolldown
  cmp.w #56,d2
  beq.b kbd_scrollup
  cmp.w #54,d2
  beq.b kbd_scrollright
  cmp.w #52,d2
  beq.b kbd_scrollleft
  cmp.w #265,d2         ;APPS
  beq.b kbd_pause
  cmp.w #KEY_DIAMOND+$10B,d2
  beq.b kbd_apd

kbd_nokey:
  clr.l d0
  lea exitdata(pc),a0
  move.b (a0),d0
  clr.b (a0)
kbd_exitproc:
  movem.l (a7)+,d1-d2/a0
  rts

kbd_left:
  sub #1,d0

;** LAME WAY OF OPTIMIZING
;  bra kbd_domove
 add #1,d1

kbd_up:
  sub #1,d1
;  bra kbd_domove
  sub #1,d0

kbd_right:
  add #1,d0
;  bra kbd_domove
  sub #1,d1

kbd_down:
  add #1,d1

kbd_domove:
  move.l d0,d2
  move.l d1,d3
  bsr move_player
  bra kbd_nokey

kbd_exitkey:
  add #2,d0
  bra kbd_exitproc

kbd_switchplayer:
  bsr switch_player
  bra kbd_nokey

kbd_scrollleft:
  sub #1,d0
;  bra kbd_scroll
  add #1,d1
kbd_scrollup:
  sub #1,d1
;  bra kbd_scroll
  sub #1,d0
kbd_scrollright:
  add #1,d0
;  bra kbd_scroll
  sub #1,d1
kbd_scrolldown:
  add #1,d1
kbd_scroll:
  bsr scroll_screen
  bra kbd_nokey

kbd_apd:
  trap #4
  bra kbd_nokey

kbd_pause:
  bsr.b zap_screen

  moveq #2,d0
  bsr set_font

  moveq #48,d0
  moveq #45,d1
  moveq #4,d2
  lea txt_pause(pc),a0
  bsr.b put_string

  bsr.b idle_loop
  bsr repaint_screen

  bra kbd_nokey


;*********
; Clear screen
;*********

zap_screen:
  movem.l a0/d0,-(a7)

  lea LCD_MEM,a0
  move.l #3840/4-1,d0

zs_next:
  clr.l (a0)+
  dbra d0,zs_next

  movem.l (a7)+,a0/d0
  rts


;********
; Wait for a keypress
;********

idle_loop:
  movem.l a0-a6/d1-d7,-(a7)

il_wait_start:
  move.l #650000,d7
il_wait:
  sub.l #1,d7
  blt.b il_apd

  moveq #100,d0
il_delay:
   dbra d0,il_delay

  lea tios::kb_globals+$1c,a0
  tst.w (a0)
  beq il_wait
  move.w tios::MaxHandles+$1E,d0
  clr.w (a0)

  cmp.w #KEY_DIAMOND+$10B,d0
  beq.b il_apd

  movem.l (a7)+,a0-a6/d1-d7
  rts

il_apd:
  trap #4
  bra il_wait_start


;********
; Put int d3 at (d0.w,d1.w) with style d2
;********

put_int:
  movem.l d0-d2,-(a7)
  move.w d3,-(a7)
  pea toint(pc)
  pea buf(pc)
  jsr tios::sprintf
  add #10,a7
  movem.l (a7)+,d0-d2
put_buf:
  lea buf(pc),a0
;  bra put string               ;Removed as it jumps to below


;*********
; Put string a0 at (d0.w,d1.w) with style d2    
;*********
put_string:
  movem.l d0-d2/a0,-(a7)
  move.w d2,-(a7)
  move.l a0,-(a7)
  move.w d1,-(a7)
  move.w d0,-(a7)
  jsr tios::DrawStrXY
  add #10,a7
  movem.l (a7)+,d0-d2/a0
  rts



;*********
; Main screen
;*********
main_screen:

  bsr zap_screen

  moveq #2,d0
  bsr set_font

  moveq #32,d0
  moveq #2,d1
  moveq #4,d2
  lea txt_title(pc),a0
  bsr.b put_string

  moveq #1,d0
  bsr set_font

  moveq #48,d0
  moveq #15,d1
  lea txt_name(pc),a0
  bsr put_string

  moveq #32,d0
  moveq #25,d1
  lea txt_email(pc),a0
  bsr put_string

  moveq #8,d0
  moveq #42,d1
  lea foldrmsg(pc),a0
  bsr put_string

  moveq #50,d1
  lea gamepakmsg(pc),a0
  bsr put_string

  moveq #58,d1
  lea levelmsg(pc),a0
  bsr put_string

  lea minmovemsg(pc),a0
  moveq #74,d1
  bsr put_string

  lea besttimemsg(pc),a0
  moveq #82,d1
  bsr put_string


;**********************************
; START OF FILEHANDLER CODE
;  a6 - current folder position (in VAT)
;  d6 - Current folder index
;  d4 - Num folders

;  d5 - Current file index
;  d3 - Num files
;  a5 - current file posision (in VAT)

;  a4 - ptr to start and endvalues
;  a3 - ptr to cur level
;  d7 - Index of level
;**********************************

  tst.l levelptrindex(a4)                   ;Check if we should load a previous game
  beq.b ft_dontload
    move.l a4,a0
    move.w (a0)+,d3
    move.w (a0)+,d4
    move.w (a0)+,d5
    move.w (a0)+,d6
    move.w (a0)+,d7
    add #2,a0
    move.l (a0)+,a3
    move.l (a0)+,a5
    move.l (a0)+,a6
    bra.b PutFolderName
ft_dontload:

  moveq #8,d0
  tios::DEREF d0,a6             ;a6 contains list of folders

  add.l #2,a6                   ;2 for numfolders position

  move.w (a6)+,d4               ;Get number of folders to d4
  sub #1,d4                     ;Subtract one from d4
  clr.l d6                      ;Current folder index

m_findtracks:
  move 12(a6),d0                ;Get handle of first folder to d0

  clr.l d3
  tios::DEREF d0,a0             ;Get ptr from handle
  add #2,a0
  move.w (a0)+,d0               ;Get num files in folder
  tst.w d0                               
  beq.b ft_empty                  ;Quit if it's zero
  sub.w #1,d0
ft_search:
  move.w 12(a0),d2                       
  tios::DEREF d2,a2             ;Get ptr for first file in folder
  cmp.w #QUIRKIDENT,2(a2)
  bne.b ft_ignore                 ;If the ident is invalid, ignore this file
  tst.w d3
  bne.b ft_notfirstfile
  move.l a0,a5
ft_notfirstfile:
  add.w #1,d3
ft_ignore:
  add #14,a0
  dbra d0,ft_search
ft_empty:
  sub #1,d3

  clr.l d5                      ;Clear current file index
  move.l d5,a3                  ;Clear current level ptr
  clr.l d7                      ;Clear level index

PutFolderName:
  moveq #62,d0
  moveq #42,d1
  moveq #4,d2
  lea empty_str(pc),a0
  bsr put_string
  clr.l d2
  clr.b 8(a6)
  move.l a6,a0
  bsr put_string                ;Put name of folder

  tst.w d3
  bge ScanTrack                 ;If the folder contain a file, jump to the find-first file routine

  ;d0 is already #62 so we don't have so set that one
  moveq #50,d1
  moveq #4,d2
  lea notrack(pc),a0
  bsr put_string                ;Put NONE string
  bsr emptylevel

ft_idle:
  bsr idle_loop           ;Wait for keypress

  cmp.w #264,d0
  beq ft_quit

  cmp.w #271,d0                 ;F4
  beq.b PreviousFolder
  cmp.w #272,d0                 ;F5
  beq.b NextFolder
  tst.w d3
  blt ft_idle
  cmp.w #337,d0                 ;Up
  beq.b PreviousTrack
  cmp.w #340,d0                 ;Down
  beq.b NextTrack
  cmp.w #13,d0                  ;Enter
  beq ft_enter

  cmp.w #338,d0                 ;Left
  beq PrevLevel
  cmp.w #344,d0                 ;Right
  beq NextLevel
  bra ft_idle

PreviousFolder:
  tst.w d6
  beq ft_idle
  sub #14,a6
  sub #1,d6
  bra m_findtracks

NextFolder:
  cmp d4,d6
  beq ft_idle
  add #1,d6
  add #14,a6
  bra m_findtracks

NextTrack:
  moveq.w #14,d2
  bra.b SearchNext

PreviousTrack:
  moveq #-14,d2

SearchNext:
  tst.l   d2
  blt.b     snf_up
  cmp.w   d3,d5
  beq.b     snf_end
  add.w   #1,d5
  bra.b     snf_rep
snf_up:
  tst.w   d5
  beq.b     snf_end
  sub.w   #1,d5
snf_rep:
  add.l   d2,a5
  move.w  12(a5),d0
  tios::DEREF d0,a2
  cmp.w   #QUIRKIDENT,2(a2)
  bne.b   snf_rep
snf_end:
  clr.l d7              ;Clear level index

ScanTrack:
  moveq #62,d0
  moveq #50,d1
  moveq #4,d2
  lea empty_str(pc),a0
  bsr put_string
  clr.l d2
  move.l a5,a0
  bsr put_string        ;Put name of gamepak
  move.w  12(a5),d2
  tios::DEREF d2,a2

  add #2,a2             ;Now A2 points to the gamepak data

  bra.b PutLevelCnt

PrevLevel:
  tst.w d7
  bgt.b PrevLevelOk
  move.w 2(a2),d7
  add #1,d7
PrevLevelOk:
  sub #1,d7
  bra.b PutLevelCnt

NextLevel:
  cmp.w 2(a2),d7
  blt.b NextLevelOk
  moveq #-1,d7
NextLevelOk:
  add #1,d7

PutLevelCnt:            ;This routine displays level specific data
  move.l d3,-(a7)
  move.l d7,d3
  add #1,d3
  bsr.b emptylevel        ;This one sets d0,d1,d2
  clr.l d2
  bsr put_int           ;Put level number

  move.w d7,d2          ;Get offset in file for this level
  add.w d7,d2           ;*2 for a valid offset
  move.w 4(a2,d2.w),d2  ;Get level offs to d2

  lea 0(a2,d2.w),a3     ;Get start of level to a3

  moveq #4,d2
  moveq #74,d1
  moveq #70,d0
  move.l a3,a0
  bsr.b put_highscore_name ;Put highscore name

  moveq #112,d0
  move.w 6(a3),d3        ;Put highscore
  bsr put_int

  moveq #82,d1
  moveq #70,d0
  lea 3(a3),a0
  bsr.b put_highscore_name  ;Put best time name

  moveq #112,d0
  move.w 8(a3),d3
  bsr put_int           ;Put best time

  move.l (a7)+,d3
  bra ft_idle

emptylevel:             ;Call with bsr, note that the d0,d1,and d2 are used after this proc
  moveq #74,d1
  moveq #4,d2
  lea empty_str_long(pc),a0
  moveq #70,d0
  bsr put_string        ;Fill best movement
  moveq #82,d1
  bsr put_string        ;Fill best time
  add #5,a0
  moveq #58,d1
  moveq #62,d0
  bra put_string        ;Fill level, Instead of bsr put_string,rts

ft_enter:
    move.l a4,a0
    move.w d3,(a0)+
    move.w d4,(a0)+
    move.w d5,(a0)+
    move.w d6,(a0)+
    move.w d7,(a0)+
    move.w 2(a2),(a0)+
    move.l a3,(a0)+
    move.l a5,(a0)+
    move.l a6,(a0)+
    bra.b ft_exit
ft_quit:
    clr.l levelptrindex(a4)
ft_exit:
  bsr zap_screen
  rts


;*********
;Set Font to d0.w
;*********
set_font:
  movem.l d0-d2,-(a7)
  move.w d0,-(a7)
  jsr tios::FontSetSys
  add #2,a7
  movem.l (a7)+,d0-d2
  rts



;**********
; PutHighscoreName draws 3 chars,as pointer to by a0
;**********
put_highscore_name:
  move.l a1,-(a7)
  lea buf(pc),a1
  move.b (a0)+,(a1)+
  move.b (a0)+,(a1)+
  move.b (a0)+,(a1)+
  move.b #0,(a1)
  move.l (a7)+,a1
  bra put_buf


;**********
; ShowLevelFinished shows the level end
;**********
show_level_finished:
  bsr zap_screen

  moveq #2,d0
  bsr set_font

  moveq #4,d2
  moveq #20,d0
  moveq #2,d1
  lea finlevel(pc),a0
  bsr put_string

  moveq #116,d0
  moveq #28,d1

  move.w movesneeded(pc),d4
  move.w d4,d3
  bsr put_int

  moveq #40,d1
  move.w timepassed(pc),d3
  bsr put_int

  moveq #1,d0
  bsr set_font

  moveq #10,d0
  moveq #30,d1
  lea nummove(pc),a0
  bsr put_string

  moveq #42,d1
  lea numtime(pc),a0
  bsr put_string

  clr.l d5
  move.l ptr_level(pc),a6
  cmp.w 6(a6),d4
  bge.b slf_nomove
    add #1,d5
slf_nomove:

  cmp.w 8(a6),d3
  bge.b slf_notime
    add #2,d5
slf_notime:

  tst.w d5
  beq.b slf_nohighscore

slf_highscore:
  moveq #65,d1
  moveq #8,d0
  lea newscore(pc),a0
  bsr put_string

  moveq #75,d1
  lea namequery(pc),a0
  bsr put_string

  lea buf(pc),a0
  bsr.b input_name

  tst.w d0
  bne.b slf_ignorehigh

  btst #0,d5
  beq.b slf_nomoverec
slf_moverec:
  move.w d4,6(a6)               ;Write min moves
  bsr.b slf_dowrite
slf_nomoverec:

  btst #1,d5
  beq.b slf_notimerec
slf_timerec:
  move.w d3,8(a6)
  add #3,a6
  bsr.b slf_dowrite
slf_notimerec:

slf_ignorehigh:
  rts
                 
slf_nohighscore:
  bsr idle_loop
  rts

slf_dowrite:
  move.b (a0)+,(a6)+
  move.b (a0)+,(a6)+
  move.b (a0)+,(a6)+            ;Write min moves name
  sub #3,a0
  sub #3,a6
  rts

  
;**********
; Get a name for the highscore, max 3 chars + one zero
; The buffer is a0, which has to be aligned
;**********

input_name:
  movem.l d1-d2,-(a7)
  move.l #$20202000,(a0)
  clr.l d7      ;Ptr in str

in_loop:
  moveq #108,d0
  moveq #75,d1
  moveq #0,d2
  bsr put_string

  bsr idle_loop
  cmp.w #13,d0
  beq.b in_finished
  cmp.w #257,d0
  beq.b in_backspace
  cmp.w #264,d0
  beq.b in_esc
  cmp.w #32,d0
  bcs.b in_loop
  cmp.w #256,d0
  bcc.b in_loop

  cmp.w #3,d7
  bge.b in_loop
  move.b d0,0(a0,d7)
  add #1,d7
  bra.b in_loop

in_backspace:
  tst.w d7
  beq.b in_loop
  sub #1,d7
  move.b #32,0(a0,d7)
  bra.b in_loop

in_esc:
  moveq #1,d0
  bra.b in_quit

in_finished:
  tst.l d7
  beq in_loop
  clr.l d0

in_quit:
  movem.l (a7)+,d1-d2
  rts



;**********
; Repaint player.
;**********

playeranims:
  dc.b cGubbe1Img1,cGubbe1Img2,cGubbe2Img1,cGubbe2Img2,cGubbe3Img1,cGubbe3Img2,cGubbe4Img1,cGubbe4Img2

 even
repaint_player_switch:
  movem.l a0-a2/d0-d1,-(a7)
  lea curplayeranim(pc),a2
  eor.b #1,(a2)
;  add.b #1,(a2)
;  and.b #1,(a2)
  bra.b rp_cont

repaint_player:
  movem.l a0-a2/d0-d1,-(a7)
  lea curplayeranim(pc),a2

rp_cont:
  clr.l d0
  move.b (a2),d0        ;Load frame index in d0

  clr.l d1
  lea playeranims(pc),a0
  move.w curplayer(pc),d1
  add.w d1,d0
  add.w d1,d0

  move.b 0(a0,d0),d0
  lea specimg+1(pc),a0
  move.b d0,0(a0,d1)

  lea SpriteStart(pc),a0
  asl #shiftpersprite,d0
  add.w d0,a0

  lea ply1x(pc),a1
  asl #2,d1
  add d1,a1

  move.w (a1)+,d0
  move.w (a1),d1
  bsr put_sprite

  movem.l (a7)+,a0-a2/d0-d1
  rts

;********
; Scroll so that the player is centered
;********

scroll_to_player:
  lea ply1x(pc),a0
  move.w curplayer(pc),d1
  add.w d1,a0
  add.w d1,a0
  move.w (a0)+,d0
  move.w (a0)+,d1
  bra.b scroll_center     ;Scroll to player center and repaint


;**********
; Auto scroll so that (d0,d1) becomes visible
;**********
auto_scroll:
  movem.l d0-d3/a0,-(a7)

  clr.l d2
  clr.l d3

  lea scrollx(pc),a0

  sub #1,d0
  sub #1,d1

  sub.w (a0)+,d0
  ble.b as_scrollh
  cmp.w #20-1-2,d0
  blt.b as_dontscrollh
as_scrollh:
  move.l d0,d2
  sub #10-1,d2
as_dontscrollh:

  sub.w (a0),d1
  ble.b as_scrollv
  cmp.w #12-1-2,d1
  blt.b as_dontscrollv
as_scrollv:
  move.l d1,d3
  sub.l #6-1,d3 
as_dontscrollv:

  tst.w d2
  bne.b as_doscroll
  tst.w d3
  beq.b as_dontscroll
as_doscroll:

  move.l d2,d0
  move.l d3,d1

  bsr.b scroll_screen
as_dontscroll:
  movem.l (a7)+,d0-d3/a0
  rts


;**********
; Scroll so that (d0,d1) is in the center and repaint
;**********
scroll_center:
  sub #10,d0            ;Blocks per screenwidth/2
  sub #6,d1             ;Blocks per screenheight/2
  lea scrollx(pc),a0
  sub.w (a0)+,d0
  sub.w (a0),d1
  bsr.b scroll_screen
  rts

;**********
; Scroll screen d0 steps to the right and d1 steps down and repaint
;**********

scroll_screen:
  lea scrollx(pc),a0
  add.w d0,(a0)
  bge.b ss_nxzero
    clr.w (a0)
ss_nxzero:

  move.w maxw(pc),d2
  sub.w #20-1,d2
  bge.b ss_maxw_dontfix
    clr.w d2
ss_maxw_dontfix:
  cmp.w (a0),d2
  bge.b ss_nxmax
    move.w d2,(a0)
ss_nxmax:

  add #2,a0
  add.w d1,(a0)
  bge.b ss_nyzero
    clr.w (a0)
ss_nyzero:

  move.w maxh(pc),d2 
  sub.w #12-1,d2
  bge.b ss_maxh_dontfix
    clr.w d2
ss_maxh_dontfix:
  cmp.w (a0),d2
  bge.b ss_nymax
    move.w d2,(a0)
ss_nymax:
  bsr.b repaint_screen
  rts

;*********
;Repaint screen with (20x12) blocks at current scrollpos
;*********

repaint_screen:
  movem.l d0-d3,-(a7)

  move.w scrolly(pc),d1
  moveq.l #12-1,d3
rs_nextrow:
  moveq.l #20-1,d2
  move.w scrollx(pc),d0
rs_nextcol:
  bsr put_q_block
  add #1,d0
  dbra d2,rs_nextcol
  add #1,d1
  dbra d3,rs_nextrow

  movem.l (a7)+,d0-d3
  rts
  

;***********
; Switch to next player
;***********
switch_player:
  movem.l d1-d2/a0-a1,-(a7)
  moveq #4,d2
  lea ply1x(pc),a0
  lea curplayer(pc),a1
swp_next:
  sub #1,d2
  blt.b swp_levelfinished
  add.w #1,(a1)
  and.w #3,(a1)
  move.w (a1),d1
  asl #2,d1
  cmp.w #255,0(a0,d1.w)
  beq.b swp_next

  bsr scroll_to_player
  bra.b swp_exit

swp_levelfinished:
  or.b #1,(exitdata)
swp_exit:
  movem.l (a7)+,d1-d2/a0-a1
  rts
 


;*********
; Delay
;*********
; d2.w - amount
;*********
do_delay:
  movem.l d0,-(a7)

dd_loop:
  move.w #$FF,d0
  dd_loop2:
    nop
    nop
    nop
  dbra.w d0,dd_loop2
  dbra.w d2,dd_loop

  movem.l (a7)+,d0
  rts



;*******************
; Format for gamepak
;*******************
; ident:word       ;"QK"
; numlevels:word   ;Number of levels-1, must not be <0
; leveloffs:word[] ;level offsets from beginning of gamepak
; levels.....


;*******************
; Format for level
;*******************
; hiscore:word
; hiscorename:char[4]
; specmask:byte    ;Mask for next bytes, 1=p1,2=p2,4=p3,8=p4,16=end
; ox,oy:[0]        ;specdatas

; NumObjects:byte  ;Number of objects
; objects:dword[0] ;array of objects

; numboards:byte;  ;Number of boards

; l,t,w,h,m:byte         ;Width and height of image, w has to be divisable by 4, m is bits to set
; board:byte[0]          ;board, each bit is a value, the data is reversed
;*******************

ll_expandblock:
  ;d0 - temp
  ;d1 - height
  ;d2 - width
  ;d3 - bits
  ;d4 - temp width
  ;d5 - temp counter
  ;a0 - ptr to data
  ;a1 - ptr to dest
  ;a2 - ptr to xmax,ymax data
  ;a3 - tmp ptr to dest

  clr.l d0
  clr.l d1
  clr.l d2

  move.b (a0)+,d1               ;Left
  move.b (a0)+,d0               ;Top
  move.w d0,d4
  asl.w #shiftperrow,d0
  add.w d1,d0
  add.w d0,a1                   ;Ptr+=Left + Top * 32

  move.b (a0)+,d2               ;Width

  move.w d1,d0
  add.w d2,d0                   ;Left+Width

  cmp.w (a2),d0
  blt.b ll_expanddata_dontx
    move.w d0,(a2)
ll_expanddata_dontx:

  add.w #7,d2                   ;Make width aligned
  asr.w #3,d2

  move.b (a0)+,d1               ;Height
  add.w d1,d4                   ;top + height

  cmp.w 2(a2),d4
  blt.b ll_expanddata_donty
    move.w d4,2(a2)
ll_expanddata_donty:

  move.b (a0)+,d3               ;Mask

  sub #1,d2
  blt.b ll_expanddata_end
  sub #1,d1
  blt.b ll_expanddata_end

ll_expanddata_row:
  move.l a1,a3
  move.l d2,d4
ll_expanddata_col:
  move.b (a0)+,d0
  moveq.l #7,d5
ll_expanddata_again:
  asr.b #1,d0
  bcc.b ll_expanddata_ignore
    or.b d3,(a3)
ll_expanddata_ignore:
  add #1,a3
  dbra d5,ll_expanddata_again
  dbra d4,ll_expanddata_col
  add #32,a1
  dbra d1,ll_expanddata_row
ll_expanddata_end:  
  rts

;**********
; Load level a0
;**********
; a0 - ptr to level to load
;**********

load_level:
  movem.l d0-d6/a1-a4,-(a7)

  clr.l d3
  add #10,a0             ;Ignore the highscore

;Initialize special areas
  move.b (a0)+,d2
  lea ply1x(pc),a1
  moveq #8-1,d0
ll_setpos:
  asr #1,d2
  bcc.b ll_setpos_dont
  move.b (a0)+,d3
  move.w d3,(a1)+
  move.b (a0)+,d3
  move.w d3,(a1)+
  bra.b ll_setpos_cont
ll_setpos_dont
  move.l #$00FF00FF,(a1)+
ll_setpos_cont:
  dbra d0,ll_setpos

;Copy objects
  move.b (a0)+,d3
  lea num_objects(pc),a1
  move.w d3,(a1)
  sub.w #1,d3
  blt.b ll_endcopyobj
  move.l objptr(pc),a1
ll_copyobj:
  move.l (a0)+,(a1)+
  dbra.w d3,ll_copyobj
ll_endcopyobj:

;Fill the area with walls
  move.l areaptr(pc),a1
  move.l a1,a4
  move.w #1024/4-1,d0
ll_clearmem:
  clr.l (a1)+
  dbra.w d0,ll_clearmem

  lea scrollx(pc),a1
  clr.l (a1)+
  clr.l (a1)+            ;Clear curplayer & nummoves too
  clr.l (a1)             ;Clear maxw,maxh

;Put the boards
  lea maxw(pc),a2
  clr.l d6
  move.b (a0)+,d6
  sub #1,d6
ll_expandnext:
  move.l a4,a1
  bsr ll_expandblock
  dbra d6,ll_expandnext

;End

  lea ply1x(pc),a0
  clr.l d0
  moveq #3,d1
dsbs_initplynum:
  cmp.w #255,(a0)
  bne.b dsbs_initply_end
  add #1,d0
  add #4,a0
  dbra d1,dsbs_initplynum
  clr.l d0
dsbs_initply_end:
  lea curplayer(pc),a0
  move.w d0,(a0)

  movem.l (a7)+,d0-d6/a1-a4
  rts

  

;***********
; Draw a spinning block in a spinning style
;**PARAMS***
; a0 - Ptr to block
;**LOCALS***
; d1 - a0.arms
;***********


dsbs_betweenblocks:
  dc.b 0,4+cLTSImg,5+cLTSImg,cLTSImg
  dc.b 0,6+cLTSImg,4+cLTSImg,1+cLTSImg
  dc.b 0,7+cLTSImg,6+cLTSImg,2+cLTSImg
  dc.b 0,7+cLTSImg,5+cLTSImg,3+cLTSImg

 even
draw_spin_block_spin:
  movem.l d0-d5/a0-a3,-(a7)

;  move.b 3(a0),d1
;  move.b type_of_spinning(pc),d0
;  tst.b d0
;  beq.b dsbs_isclock
;    move.b d1,d0
;    asl #3,d0
;    asr #1,d1
;    or d0,d1
;dsbs_isclock:
;  and.l #$F,d1

  lea dsbs_temp(pc),a3
  lea dsbs_betweenblocks(pc),a2

  ;Clear the tempdata, 8 doesn't need to be cleared
  clr.l (a3)
  clr.l 4(a3)

  btst #0,d2
  beq.b dsbs_dontarm1
    move.b #cTLSArmImg,6(a3)
dsbs_dontarm1:

  btst #1,d2
  beq.b dsbs_dontarm2
    move.b #cTRSArmImg,4(a3)
dsbs_dontarm2:

  btst #2,d2
  beq.b dsbs_dontarm4
    move.b #cRBSArmImg,2(a3)
dsbs_dontarm4:             

  btst #3,d2
  beq.b dsbs_dontarm8
    move.b #cLBSArmImg,(a3)
dsbs_dontarm8:

  move.w d2,d1
  asr.w #2,d1
  and.b #3,d1
  move.b 8(a2,d1.w),1(a3)

  move.w d2,d1
  asr.w #1,d1
  and.b #3,d1
  move.b 4(a2,d1.w),3(a3)

  move.w d2,d1
  and.b #3,d1
  move.b 0(a2,d1.w),5(a3)

  move.w d2,d1
  and.b #1,d1
  move.w d2,d0
  and.b #8,d0
  asr.b #2,d0
  or.w d0,d1
  move.b 12(a2,d1.w),7(a3)

  add #cLCSImg-1,d2
  move.b d2,8(a3)

  lea.l SpinXKoord(pc),a2

  moveq.l #8,d2

  clr.l d4
  clr.l d5
  move.b (a0),d4
  move.b 1(a0),d5
  
dsbs_draw_img:
  move.l d4,d0
  add.b (a2)+,d0
  move.l d5,d1
  add.b num_between_spink-1(a2),d1

  clr.l d3
  move.b (a3)+,d3
  tst.b d3
  beq.b dsbs_ignore_this

  asl #shiftpersprite,d3
  lea SpriteStart(pc),a0
  add.l d3,a0
  bsr put_sprite

dsbs_ignore_this:
  dbra d2,dsbs_draw_img

  movem.l (a7)+,d0-d5/a0-a3
  rts

;**********
; Draw kwirk block # (X,Y)
; This one preserves all regs, even the params
;**********
; d0.w - X
; d1.w - Y
;**********


pqb_err:
  rts

put_q_block:
  ;Check against bounds
  tst d0
  blt pqb_err
  tst d1
  blt pqb_err
  cmp.w #32,d0
  bge pqb_err
  cmp.w #32,d1
  bge pqb_err

  movem.l d0-d4/a0-a1,-(a7)

  bsr obj_from_pos ;d0=X, d1=Y, result=d2
  cmp.l #0,a0
  bne pb_object

pqb_normal:
  ; Transform the X and Y koordinate to a pointer(a0) in the area
  move.w d1,d2
  asl #shiftperrow,d2
  add.w d0,d2
  move.l areaptr(pc),a0
  add.w d2,a0

  ; Get the value of the item in this area
  move.b (a0),d2

  ; Check if it is a wall, ie 0
  tst.b d2
  bne.b pb_isnot0

  ;Check if there is a wall to the left
pb_checkwallleft:
  tst.w d0
  ble.b pb_checkwallabove
  tst.b -1(a0)
  beq.b pb_checkwallabove
  or.b #1,d2

;***SIZE OPTIMIZED -- Not nesseccary as the blocks look the same if there is a wall above
  ;Check if there is a wall above
pb_checkwallabove:
;  tst.w d1
;  ble pb_checkwallright
;  tst.b -32(a0)
;  beq pb_checkwallright
;  or.b #2,d2
;;***SIZE OPTIMIZED -- Not nesseccary

  ;Check if there is a wall to the right
pb_checkwallright:
  cmp.w #32-1,d0
  bge.b pb_checkwallbelow
  tst.b 1(a0)
  beq.b pb_checkwallbelow
;***CHANGED FROM or.b #4,d2 BECAUSE OF OPTIMIZE
  or.b #2,d2

  ;Check if there is a wall below
pb_checkwallbelow:
  cmp.w #32-1,d1
  bge.b pb_finishwall
  tst.b 32(a0)
  beq.b pb_finishwall
;***CHANGED FROM or.b #8,d2 BECAUSE OF OPTIMIZE
  or.b #4,d2

pb_finishwall:
  ;Add this value to move the index to the right sprite
  add #cEmptyWImg,d2
  bra.b pb_drawsprite

pb_isnot0:
  ;Check if it is a floor, if not, branch
  cmp.b #1,d2
  bne.b pb_isnot1

  bsr specobj_from_pos
  cmp.w #5,d2
  bne.b pb_specobjnotend
  lea keyx(pc),a0
  cmp.w #255,(a0)
  beq.b pb_specobjnotend
  moveq #keyident,d2
pb_specobjnotend:
  lea specimg(pc),a0
  move.b 0(a0,d2),d2

  bra.b pb_drawsprite

pb_isnot1:
  moveq #cBlackImg,d2
;  bra pb_drawsprite

pb_drawsprite:
  ;As d0 is X, and d1 is Y, we don't need to move those in order to call the proc
  ;But we need to point a0 to the sprite to paint, index d3.b

  lea SpriteStart(pc),a0
  and.w #$FF,d2
  asl #shiftpersprite,d2
  add.w d2,a0

  bsr put_sprite

  movem.l (a7)+,d0-d4/a0-a1
  rts

pb_object:
  ;Clear the image index
  clr.l d2

  ;Store the diffs for faster access
  move.b d0,d3
  sub.b (a0),d3
  move.b d1,d4
  sub.b 1(a0),d4

  ;Check if it's a solid or spin block
  tst.b 2(a0)
  beq.b pb_spinner

pb_solidblock:
  tst.b d3
  bne.b pb_s_noleft
  or.b #1,d2
pb_s_noleft:
  add.l #1,d3
  cmp.b 2(a0),d3
  bne.b pb_s_noright
  or.b #4,d2
pb_s_noright:
  tst.b d4
  bne.b pb_s_notop
  or.b #2,d2
pb_s_notop:
  add.l #1,d4
  cmp.b 3(a0),d4
  bne.b pb_s_nobottom
  or.b #8,d2
pb_s_nobottom:
  add.b #cEmptyBImg,d2
  bra pb_drawsprite

pb_spinner:
  cmp.b #1,d3
  bne.b pb_sp_noc        ;Not in center
  cmp.b #1,d4
  beq.b pb_sp_c          ;In center

pb_sp_noc:
  moveq #cBArmImg,d2
pb_sp_notspinning:
  cmp #2,d3
  beq.b pb_sp_larm
  tst.b d4
  beq.b pb_sp_barm
  cmp.b #2,d4
  beq.b pb_sp_tarm
pb_sp_rarm:
  add #1,d2
pb_sp_tarm:
  add #1,d2
pb_sp_larm:
  add #1,d2
pb_sp_barm:
  bra pb_drawsprite

pb_sp_c:
  move.b 3(a0),d2
  add.b #cLSBImg-1,d2
  bra pb_drawsprite

;**********
; Find the special object at pos (d0.w,d1.w)
;**********
; d0.w - X
; d1.w - Y
; Returns the value in d2.w
; Destroys A0
;**********

specobj_from_pos:
  lea ply1x(pc),a0
  moveq.l #numspecitem-1,d2
sfp_again:
  cmp.w (a0),d0
  bne.b sfp_next
  cmp.w 2(a0),d1
  bne.b sfp_next
  sub.l #numspecitem,d2
  neg.l d2
  rts

sfp_next:
  add #4,a0
  dbra d2,sfp_again
  clr.l d2
  rts

;**********
; Lookup an object from x and y, return a ptr in a0
;**********
; d0.w - X
; d1.w - Y
; a0 - result
;**********

obj_from_pos:
  movem.l d2-d4,-(a7)

  move.l objptr(pc),a0
  move.w num_objects(pc),d2

  sub #4,a0
ofp_again:
  add #4,a0
  sub.w #1,d2
  tst.w d2
  blt.b ofp_end
  ;Store the diffs for faster access
  move.b d0,d3
  sub.b (a0),d3
  move.b d1,d4
  sub.b 1(a0),d4

  ;Check if the koords are less than the block's X or Y value
  tst.b d3
  blt ofp_again
  tst.b d4
  blt ofp_again

  ; Is it a spinner, or a solid block?
  tst.b 2(a0)
  beq.b ofp_isspinner

ofp_solidblock:
  ;Check if the koords are within the block
  cmp.b 2(a0),d3
  bge ofp_again
  cmp.b 3(a0),d4
  bge ofp_again
  bra.b ofp_ok_exit

ofp_isspinner:
  ;Check if the koord are on one of the arms or the center
  cmp.b #3,d3
  bge ofp_again
  cmp.b #3,d4
  bge ofp_again

  cmp.b #1,d3
  bne.b ofp_i_checkother
  tst.b d4
  beq.b ofp_checkarm2
  cmp.b #2,d4
  bne.b ofp_ok_exit ; If it's neither 0 nor 2, then it's 1=center. success.
ofp_checkarm8:
  btst #3,3(a0)
  bne.b ofp_ok_exit ; The koord is in the bottom arm
  bra ofp_again
ofp_checkarm2:
  btst #1,3(a0)
  bne.b ofp_ok_exit ; The koord is in the top arm
  bra ofp_again

ofp_i_checkother: 
  cmp.b #1,d4     
  bne ofp_again
  tst.b d3
  beq.b ofp_checkarm1
  cmp.b #2,d3
  bne ofp_again
ofp_checkarm4:
  btst #2,3(a0)
  bne.b ofp_ok_exit ; The koord is in the right arm
  bra ofp_again
ofp_checkarm1:
  btst #0,3(a0)
  bne.b ofp_ok_exit ; The koord is in the left arm
  bra ofp_again
ofp_end:
  clr.l d3
  move.l d3,a0
ofp_ok_exit:
  movem.l (a7)+,d2-d4
  rts

;**********
;Repaints the block object a0 and the area around
;**********
; a0 - Block to repaint
;**********

repaint_block_object:
  movem.l d0-d5,-(a7)

  clr.l d5
  clr.l d1
  clr.l d2
  clr.l d3
  move.b (a0),d5
  and.b #127,d5
  move.b 1(a0),d1
  move.b 2(a0),d2
  move.b 3(a0),d3

  tst.b d2
  bne.b rbo_solidblock
    moveq #3,d2
    moveq #3,d3
rbo_solidblock:

  sub #1,d5
  sub #1,d1
  add #1,d2
  add #1,d3

rbo_nextrow:
  move.l d2,d4
  move.l d5,d0
rbo_nextcol:
  bsr put_q_block
  add #1,d0
  dbra d4,rbo_nextcol
  add #1,d1
  dbra d3,rbo_nextrow

  movem.l (a7)+,d0-d5
  rts


;**********
;Check if the area pointer to by (d5.w,d6.w) is blocked by another object than a6
;**********
; d5.w - X
; d6.w - Y
; a6 - Ptr to ignore
; d7.b - result
;**********

;area_is_blocked_nohole:
;  movem.l d0-d2/a0-a1,-(a7)
;  moveq #1,d2
;  bra ais_cont

area_is_blocked:
  movem.l d0-d2/a0-a1,-(a7)
  clr.l d2
ais_cont:

  move.w d6,d0
  asl #shiftperrow,d0
  add.w d5,d0
  move.l areaptr(pc),a1
  add.w d0,a1

  tst.b (a1)
  beq.b ais_isblocked

;  tst.l d2
;  beq ais_checkobject

;  cmp.b #2,(a1)
;  beq ais_isblocked

ais_checkobject:
  move.l d5,d0
  move.l d6,d1
  bsr obj_from_pos
  move.l a0,d2
  tst.l d2
  beq.b ais_checkspecobj
  cmp.l d2,a6
  beq.b ais_checkspecobj

ais_isblocked:
  moveq #1,d7
  bra.b ais_quit

ais_checkspecobj:
  bsr specobj_from_pos
  tst.l d2
  beq.b ais_notblocked
  sub.w #1,d2
  cmp.w curplayer(pc),d2
  bne ais_isblocked

ais_notblocked:
  clr.l d7
ais_quit:
  movem.l (a7)+,d0-d2/a0-a1
  rts


;**********
; Move the player d2.w steps to the right and d3.w steps down
;**********
; d2.w - MX
; d3.w - MY
;**********
; d0.w - NewX
; d1.w - NewY
; d4 - Temp
; d5 - Temp
; d6 - Temp
;**********

move_player:
  movem.l d0-d7/a1-a4/a6,-(a7)

  ;Calc the new koords, a4 is a ptr to the current player pos
  move curplayer(pc),d0
  asl #2,d0
  lea ply1x(pc),a4
  add d0,a4
  move.w (a4),d0
  move.w 2(a4),d1

  add.w d2,d0
  add.w d3,d1

  ;Get a ptr to Area[X+Y*32] in a1
  move.w d1,d4
  asl #shiftperrow,d4
  add.w d0,d4
  move.l areaptr(pc),a1
  add.w d4,a1
  ;Check if the byte there is a 1, ie floor
  cmp.b #1,(a1)
  bne mp_isnotfloor

  move.l d2,d5
  bsr specobj_from_pos
  move.b d2,curspecobj
  tst.b d2
  beq.b mp_isfloor
  cmp.b #4,d2
  ble mp_invalid_move           ;Don't allow movement over another player

  ;Check if the door is locked
  cmp.b #5,d2
  bne.b mp_isfloor
  lea keyx(pc),a1
  cmp.w #255,(a1)
  bne mp_invalid_move

mp_isfloor:
  move.l d5,d2

  ;Get block object at (x,y)
  bsr obj_from_pos

  ;Was there one?
  cmp.l #0,a0
  beq mp_normalfloor ;No, just process it as an empty floor

  move.l a0,a6          ;Store it in a6, as area_is_blocked wants it like that

mp_objectonfloor:
  clr.l d4
  clr.l d5
  clr.l d6
  move.b (a0),d5        ;The X koordinate for the block
  move.b 1(a0),d6       ;The Y koordinate for the block

  ;Check if it's a solid block or a spinner block
  tst.b 2(a0)
  beq mp_spinblock      ; It is a spinner block, branch

mp_solidblock:
  ;check if is is a horizontal or vertical movement
  tst.w d2
  beq.b mp_solid_vertmove

mp_solid_horizmove:
  ;Check which direction the block is moved, and add values
  ;to prepare a check if the block is movable
  blt.b mp_solid_h_1
    add.b 2(a0),d5
    add #1,d5
mp_solid_h_1:
  sub #1,d5
  blt mp_invalid_move

  move.b 3(a0),d4
  sub #1,d4

mp_h_check_again:
  bsr area_is_blocked
  tst.b d7
  bne mp_invalid_move
  add #1,d6
  dbra.w d4,mp_h_check_again
  bra.b mp_solid_moveit

mp_solid_vertmove:
  tst.w d3
  blt.b mp_solid_v_1
    add.b 3(a0),d6
    add #1,d6
mp_solid_v_1:
  sub #1,d6
  blt mp_invalid_move

  move.b 2(a0),d4
  sub #1,d4

mp_v_check_again:
  bsr area_is_blocked
  tst.b d7
  bne mp_invalid_move
  add #1,d5
  dbra d4,mp_v_check_again

mp_solid_moveit:
  ;Move the block object
  add.b d2,(a0)
  add.b d3,1(a0)

  ;Now, check if the block object should fall down and form new floor
  ;Get start coord in area
  clr.l d2
  clr.l d3
  move.b (a0),d3
  move.b 1(a0),d2
  asl #shiftperrow,d2
  add d3,d2
  move.l areaptr(pc),a1
  add.l d2,a1
  move.l a1,a2

  clr.l d5
  move.b 3(a0),d5
  sub #1,d5

  clr.l d6
  move.b 2(a0),d6
  sub #1,d6

  move.l d5,d2
mp_solid_cfalldown_row:
  move.l a1,a3
  move.l d6,d3
mp_solid_cfalldown_col:
  cmp.b #2,(a3)+
  bne.b mp_solid_dontfall
  dbra d3,mp_solid_cfalldown_col
  add #32,a1
  dbra d2,mp_solid_cfalldown_row

mp_solid_falldown:
  move.l d5,d2
mp_solid_falldown_row:
  move.l a2,a3
  move.l d6,d3
mp_solid_falldown_col:
  move.b #1,(a3)+
  dbra.b d3,mp_solid_falldown_col
  add #32,a2
  dbra.b d2,mp_solid_falldown_row

  or.b #128,(a0) 
mp_solid_dontfall:
  bsr repaint_block_object
  bra mp_normalfloor

mp_spinblock:
  sub.w d0,d5
  sub.w d1,d6
  clr.l d4
  move.b 3(a0),d4

  tst.w d5
  bne.b mp_spin_notarm1
  btst #0,d4
  beq.b mp_spin_notarm1
  tst.w d3
  bgt.b mp_spin_unclock
  blt.b mp_spin_clock
mp_spin_notarm1:

  tst.w d6
  bne.b mp_spin_notarm2
  btst #1,d4
  beq.b mp_spin_notarm2
  tst.w d2
  bgt.b mp_spin_clock
  blt.b mp_spin_unclock
mp_spin_notarm2:

  cmp.w #-2,d5
  bne.b mp_spin_notarm4
  btst #2,d4
  beq.b mp_spin_notarm4
  tst.w d3
  bgt.b mp_spin_clock
  blt.b mp_spin_unclock
mp_spin_notarm4:

  cmp.w #-2,d6
  bne mp_invalid_move
  btst #3,d4
  beq mp_invalid_move
  tst.w d2
  bgt.b mp_spin_unclock
  beq mp_invalid_move

mp_spin_clock:
  lea ClockSpinList(pc),a1
  add.w d4,a1

  move.w d4,-(a7)

  move.w d4,d5
  add.w d4,d4
  asr.w #3,d5
  or.w d5,d4
  and.w #$F,d4

  bra.b mp_spin_endclock

mp_spin_unclock:
  lea UnclockSpinList(pc),a1
  add.w d4,a1

  move.w d4,d5
  asr.w #1,d4
  asl.w #3,d5
  or.w d5,d4
  and.w #$F,d4

  move.w d4,-(a7)

mp_spin_endclock:

  move.w d1,-(a7)               ;Y koord
  move.w d0,-(a7)               ;X koord
  move.b 3(a0),-(a7)            ;Old arms
  move.b d4,-(a7)               ;New arms

  lea SpinXKoord(pc),a2
  lea SpinYKoord(pc),a3

  clr.l d5
  clr.l d6
  moveq.l #7,d4
mp_spin_checkagain:
  move.b (a0),d5
  add.b (a2)+,d5
  move.b 1(a0),d6
  add.b (a3)+,d6
  btst.b d4,(a1)
  beq.b mp_spin_checknext

  bsr area_is_blocked
  tst d7
  bne mp_spin_invalid_move

mp_spin_checknext:
  dbra.l d4,mp_spin_checkagain
     
mp_spin_spin:

  move.b (a7),3(a0)

  ;Check if new coords are blocked and if they are, move once again. If this is blocked, quit
  move.l d0,d5
  move.l d1,d6
  move #0,a6
  bsr area_is_blocked
  tst.w d7
  beq.b mp_dontadvance
   add.w d2,d0
   add.w d3,d1

   ;Check so that it isn't a hole
   move.w d1,d2
   asl #shiftperrow,d2
   add.w d0,d2
   move.l areaptr(pc),a1
   add.w d2,a1
   ;Check if the byte is a 2, ie hole
   cmp.b #2,(a1)
   beq.b mp_spin_invalid_move
mp_dontadvance:

  movem.l a0/a4/d0-d1,-(a7)
  move.w (a4)+,d0
  move.w (a4),d1
  lea WhiteImg(pc),a0
  bsr.b put_sprite
  movem.l (a7)+,a0/a4/d0-d1

  add.w #4,a7

  move.l (a7)+,(a4)
  move.w (a7)+,d2
  bsr draw_spin_block_spin
  bsr repaint_player
  
  move.l #120,d2
  bsr do_delay

  bsr repaint_block_object
 

mp_normalfloor:

  move.w (a4),d2
  move.w d0,(a4)+
  move.w (a4),d3
  move.w d1,(a4)

  bsr auto_scroll

  move.b curspecobj(pc),d4
  cmp.b #5,d4
  bne.b mp_isnotend
    sub #2,a4
    move.w #255,(a4)
    bsr switch_player
mp_isnotend:

  bsr put_q_block
  
  move.w d2,d0
  move.w d3,d1
  bsr put_q_block

  cmp.b #6,d4
  bne.b mp_isnotkey
    lea endx(pc),a1
    move.w #255,4(a1)
    move.w (a1)+,d0
    move.w (a1),d1
    bsr put_q_block
mp_isnotkey:

  lea movesneeded(pc),a0
  add.w #1,(a0)

mp_isnotfloor:
mp_invalid_move:
  movem.l (a7)+,d0-d7/a1-a4/a6
  rts


mp_spin_invalid_move:
  add.w #2,a7
  move.b (a7)+,3(a0)
  add.w #6,a7
  bra mp_invalid_move

;**********
; Draw a sprite at  ((X-scrollx)*8,(Y-scrolly)*8)
;**********
; d0.w - X
; d1.w - Y
; a0 - Ptr to sprite
; a1 - Destroyed
;**********

put_sprite:
  ;Adjust for the scrollpos
  lea scrollx(pc),a1
  sub.w (a1),d0
  sub.w 2(a1),d1

  ;Check bounds
  tst.w d0
  blt.b ps_err
  tst.w d1
  blt.b ps_err
  cmp.w #20,d0
  bge.b ps_err
  cmp.w #12,d1
  bge.b ps_err

  mulu.w #30*8,d1
  add.w d0,d1
  move.l #LCD_MEM,a1
  add.w d1,a1
  moveq.l #7,d0
ps_loop:
  move.b (a0)+,(a1)
  add #30,a1
  dbra.l d0,ps_loop
ps_err:
  rts


;**********
; Draw a sprite using xor at (X*8,Y*8)
;**********
; d0.w - X
; d1.w - Y
; a0 - Ptr to sprite
; a1 - Destroyed
;**********

put_sprite_xor:
  ;Adjust for the scrollpos
  lea scrollx(pc),a1
  sub.w (a1),d0
  sub.w 2(a1),d1


  ;Check bounds
  tst.w d0
  blt ps_err
  tst.w d1
  blt ps_err
  cmp.w #20,d0
  bge ps_err
  cmp.w #12,d1
  bge ps_err

  mulu #30*8,d1
  add.w d0,d1
  move.l #LCD_MEM,a1
  add.w d1,a1
  moveq.l #7,d0
psx_loop:
  move.b (a0)+,d1
  eor.b d1,(a1)
  add #30,a1
  dbra.l d0,ps_loop

  rts
  

 even

;*****************************


ClockSpinList:
  dc.b 0,2+4,8+16,2+4+8+16,32+64,1+2+32+64,8+16+32+64,2+4+8+16+32+64,
  dc.b 1+128,1+2+4+128,1+8+16+128,1+2+4+8+16+128,1+32+64+128,1+2+4+32+64+128,
  dc.b 1+8+16+32+64+128,255

UnclockSpinList:
 dc.b %00000000,%11000000,%00000011,%11000011
 dc.b %00001100,%11001100,%00001111,%11001111
 dc.b %00110000,%11110000,%00110011,%11110011
 dc.b %00111100,%11111100,%00111111,%11111111


SpinXKoord:
  dc.b 0,1,2,2,2,1,0,0,1

SpinYKoord:
  dc.b 2,2,2,1,0,0,0,1,1

num_between_spink equ 9

 even
;*****************************


areahandle dc.w 0
areaptr    dc.l 0
objptr     dc.l 0     

ply1x      dc.w 1
ply1y      dc.w 1
ply2x      dc.w 0
ply2y      dc.w 0
ply3x      dc.w 0
ply3y      dc.w 0
ply4x      dc.w 0
ply4y      dc.w 0
endx       dc.w 2
endy       dc.w 2
keyx       dc.w 0
keyy       dc.w 0
tempx      dc.w 0
tempy      dc.w 0
temp2x     dc.w 0
temp2y     dc.w 0

num_files  dc.w 0        ;0
num_folders dc.w 0       ;2
cur_file   dc.w 0        ;4
cur_folder dc.w 0        ;6
cur_level  dc.w 0        ;8
num_levels dc.w 0        ;10
ptr_level  dc.l 0        ;12
ptr_file   dc.l 0        ;16
ptr_folder dc.l 0        ;20

dsbs_temp:
buf:
  ds.b   10
 even


;Offset to player (=playnum*4)

scrollx    dc.w 0
scrolly    dc.w 0
curplayer dc.w 0
movesneeded dc.w 0

maxw       dc.w 0
maxh       dc.w 0

num_objects dc.w 0

exitdata dc.w 0
timepassed dc.w 0
curplayeranim dc.w 0


numspecitem equ 6

;specimg: dc.b cWhiteImg, cGubbe1Img, cGubbe2Img,cTLSArmImg,cTLSArmImg,cEndImg
specimg: dc.b cWhiteImg,cGubbe1Img1,cGubbe2Img1,cGubbe3Img1,cGubbe4Img1,cEndLImg,cKeyImg,0,0,cLockDoorImg

keyident equ 9

;tmpb       dc.b 0
;type_of_spinning dc.b 0
; even

;The format for the objects is as following:
;For solid blocks:
;  X.b = X koordinate, msb is set if the block has fallen down
;  Y.b = Y koordinate
;  W.b = Width, must not be 0
;  H.b = Height, must not be 0
;
;For spin blocks:
;  X.b = X koordinate
;  Y.b = Y koordinate
;  U.b = 0
;  Arms.b = Arms (1-left, 2-top, 4-right, 8-bottom)

curspecobj dc.b 0

empty_str_long dc.b "     "
empty_str    dc.b "        ",0
notrack  dc.b "none    ",0
foldrmsg   dc.b "Folder :         (F4,F5)",0
gamepakmsg dc.b "Gamepak:         (",19,20,")",0
levelmsg   dc.b "Level  :         (",17,18,")",0

minmovemsg  dc.b "Min moves:",0
besttimemsg  dc.b "Best time:",0
finlevel   dc.b "Level finished!",0
nummove    dc.b "Number of moves :",0
numtime    dc.b "Time elapsed    :",0
newscore   dc.b "It's a new level record.",0
namequery  dc.b  "Enter your name:",0
toint dc.b        "%d",0

txt_pause  dc.b "PAUSED",0
txt_title  dc.b "Kwirk v1.0",0

txt_name   dc.b "By Ludde",0

txt_email  dc.b "luddes@usa.net",0



 include qwdata.asm

_comment dc.b "Kwirk v1.0 by Ludde",0

 end



